
# LKW Part 1 - building the kernel

With the VM readily set up, we now want to actually build a kernel
ourselves.  That's actually pretty easy.

First go to the linux directory we have just created if you aren't
in the directory already anyway:

	cd ~/jrsl/linux

The configure the kernel to only build the drivers for the local
(virtual hardware):

	make defconfig
	make localmodconfig

Disable auto localversion, as that option is causing nothing but
problems:

	sed -i 's/CONFIG_LOCALVERSION_AUTO=y/CONFIG_LOCALVERSION_AUTO=n/' .config

Make sure that the NVMe driver is not enabled in the .config as we'll
write out own driver for it:

	grep NVME_ .config

This should only give results that are commented out using a #.

And the build the kernel
	
	make -j2 2>err.log

After that install the kernel and reboot into it.

	make modules_install install
	reboot

Now we are running a Linux kernel we've built ourselves, which is important
to work on it.

## Shared folder

With this new kernel we can now also enable the shared folder with the
host system.  For that edit the /etc/fstab file using your favorite
editor (I'm using vim here)

	vim /etc/fstab

And add this line to the end of it:

	shared /mnt/shared 9p trans=virtio,version=9p2000.L

And then mount this file system

	mkdir /mnt/shared
	systemctl daemon-reload
	mount /mnt/shared

This file system will not also be available when you reboot.  Test the
file system by e.g. storing all the kernel messages there:

	dmesg > /mnt/shared/dmesg

and then check that you can read this text file on the host system.

You can then use /mnt/shared by copying files to and from it in the host
and the guest.  I would not recommend to actually build the kernel in
the /mnt/shared directory as that would be very slow.
