
# Initializing the hardware

This is the first part that is specific to the NVMe hardware we deal
with, but things will still be similar for a lot of hardware.

Devices often need a few bits set, then have an enable bit flipped to 1,
and then we have to wait for it.

## Creating the NVMe submission/completions queues

NVMe is an interface that commands are submitted to and from, and this
is done through shared memory queues access by the CPU and the device.

These queue needs to be allocated before enabling the device, so we
have to allocate DMA memory for them.  The dma_alloc_coherent function
is a special memory allocator that guarantees memory can be addresses by
the device, and returns a pointer for use by the CPU in the kernel,
an and address to be used by the device.

**We are not actually making use of this queue,
  but it is required to enable the device**

(and if you have questions on the DMA allocator feel free to ask me,
 but the details are not relevant for today)

After we allocated this memory we need to tell the device about it,
and also about the size of the queue.

We pick a queue size of 2 each because it is the minimum required,
and we're not actually going to use it.

On shutdown we also have to free all this memory again.

## Enabling the NVMe device

To enable the device we need to set a few magic bits in the CC (Controller
Configuration) register, and then set the enable bit and wait for the
ready bit to be set by the controller.  Note we normally would have a
timeout for the wait, but we're going to skip this to make things simple.

On shutdown we also have to set a bit to let the device shutdown and
wait for it.

## Mapping the CMB

The CMB (Controller Memory Buffer) is some RAM on the NVMe device that
we want to use as a ramdisk.  It is found by reading data from two
registers that have really strange encodings, and then calling
pci_ioremap again.

Please just copy and past the code, as a new developer you do not
need to understand this.  If you want anyway feel free to ask me later.
